
\tikzset{
	treenode/.style = {shape=rectangle,
		draw, anchor=center,
		text width=5em, align=center,
		inner sep=1ex},
	decision/.style = {treenode, diamond, inner sep=0pt},
	root/.style     = {treenode, ellipse},
	env/.style      = {treenode},
	finish/.style   = {root, bottom color=green!40},
	dummy/.style    = {circle,draw}
}
\newcommand{\yes}{edge node [above] {بله}}
\newcommand{\no}{edge  node [left]  {خیر}}

\begin{tikzpicture}
\matrix (chart)
[
matrix of nodes,
column sep      = 3em,
row sep         = 5ex,
column 1/.style = {nodes={root}},
column 2/.style = {nodes={env}}
]
{
	|[root]| شروع &  \\
	|[env]| \rl{انتخاب ۱۰ تصویر}               &  \\	
	|[env]|    {\RTL یافتن بهترین \lr{psnr}}             & \\
	|[decision]| \rl{شباهت پیدا شده بهتر از قبلی است؟}  & {\RTL ذخیره \rl{psnr} به عنوان بهترین یافت شده} \\
	|[decision]| \rl{آیا تصویری باقی مانده است؟} &        \\
	|[env]|	\rl{\RTL نمایش تصویر بهترین \lr{psnr} یافت شده} & \\
	|[root]| \rl{پایان} & \\
};
\draw [->]	(chart-1-1) -- (chart-2-1);
\draw [->]	(chart-2-1) --  (chart-3-1);
\draw [->]	(chart-3-1) -- (chart-4-1);
\draw [->]	(chart-4-1) \no (chart-5-1);
\draw [->]	(chart-4-1) \yes (chart-4-2);
\draw [->]	(chart-5-1) \no (chart-6-1);
\draw [->]	(chart-6-1) -- (chart-7-1);
\draw [->]	(chart-4-2) |- (chart-5-1);
\draw [->]
	(chart-5-1) -- +(-3,0) |- (chart-2-1)
	node[near start,sloped,above] {بله};

\end{tikzpicture}
